<template>
  <ObModal
    ref="modal"
    :title="serviceFormTitle"
    size="md"
  >
    <ob-form
      class="order-additional-service-form"
      data-qa="additionalServiceForm"
      :form-data="formData"
      :form-model="formModel"
      :is-read-only="isReadonlyForm"
      :dropdown-menu="dropdownMenu"
      :ok-text="okTextForm"
      :is-loading="isLoading"
      :is-submit-disabled="isSubmitDisabled"
      :btn-modal="btnModal"
      @submit="onSubmitHandler"
      @on-btn-modal="toReExposeService"
    >
      <StatusBlock
        v-if="!isNew && !isToReExposeFormState"
        :service="dataSource"
        :order="order"
        :is-large="true"
        class="mb30"
      />
      <div class="row">
        <div class="col-xs-6">
          <ObInput
            label="Заказчик"
            :readonly="true"
            :value="servicesInfo.clientTitle"
            data-qa="clientTitle"
          />
        </div>
        <div class="col-xs-6">
          <ObInput
            label="Исполнитель"
            :readonly="true"
            :value="servicesInfo.contractorTitle"
            data-qa="contractorTitle"
          />
        </div>
      </div>
      <div class="row">
        <div class="col-xs-12">
          <ObSelect
            v-if="isNew"
            v-model="formData.serviceUuid"
            label="Наименование услуги"
            placeholder="Выберите услугу"
            value-exp="serviceUuid"
            display-exp="fullTitle"
            sub-title-exp="isVatTitle"
            :remote-opt="{
              method: api.orderProcess.getAdditionalServices,
              loadEvent: 'open'
            }"
            :is-standart="true"
            property="serviceUuid"
            data-qa="service"
            @selected="onSelectService"
          />
          <ObInput
            v-else
            :value="dataSource.title"
            :readonly="!isNew"
            label="Наименование услуги"
          />
        </div>
      </div>
      <transition name="fadeIn">
        <div
          v-if="formData.geography === 'WHERE'"
          class="row"
        >
          <div class="col-xs-12">
            <template v-if="isNew">
              <ObSelect
                v-model="formData.locationUuid"
                label="Локация"
                placeholder="Выберите из списка"
                :items="locationsList()"
                :is-standart="true"
                property="locationUuid"
                data-qa="locationUuid"
                display-exp="addressTitle"
                value-exp="locationUuid"
                :disabled="!isNew"
                @selected="onSelectLocation($event, 'WHERE')"
              />
            </template>
            <template v-else>
              <ObInput
                label="Локация"
                v-model="formData.visitPointAddressTitle"
                data-qa="visitPointAddressTitle"
                pre-icon="pin"
                :readonly="true"
              />
            </template>
          </div>
        </div>
        <div
          v-if="formData.geography === 'FROM_TO'"
        >
          <div class="row">
            <div class="col-xs-12">
              <ObSelect
                v-model="formData.locationFromUuid"
                label="Откуда"
                placeholder="Выберите из списка"
                :items="locationsList('FROM')"
                :is-standart="true"
                property="locationFromUuid"
                data-qa="locationFromUuid"
                :disabled="!isNew"
                @selected="onSelectLocation($event, 'FROM')"
              />
            </div>
          </div>
          <div class="row">
            <div class="col-xs-12">
              <ObSelect
                v-model="formData.locationToUuid"
                label="Куда"
                placeholder="Выберите из списка"
                :items="locationsList('TO')"
                :is-standart="true"
                property="locationToUuid"
                data-qa="locationToUuid"
                :disabled="!isNew"
                @selected="onSelectLocation($event, 'TO')"
              />
            </div>
          </div>
        </div>
      </transition>
      <transition name="fadeIn">
        <div
          v-if="Boolean(formData.serviceUuid) && (formData.geography === 'WITHOUT_GEOGRAPHY_BINDING' || formData.locationUuid || (formData.locationFromUuid && formData.locationToUuid))"
        >
          <template v-if="isInternational">
            <div class="international-block">
              <svg width="24" height="24" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
                <path fill-rule="evenodd" clip-rule="evenodd" d="M22 12C22 6.47715 17.5228 2 12 2C6.47715 2 2 6.47715 2 12C2 17.5228 6.47715 22 12 22C17.5228 22 22 17.5228 22 12ZM8.6158 17.3335C8.82662 18.1678 9.08543 18.9187 9.38254 19.562C8.37967 19.2149 7.4673 18.674 6.69025 17.984C6.88392 17.8874 7.11293 17.7873 7.38126 17.689C7.73199 17.5605 8.14212 17.4383 8.6158 17.3335ZM10.6086 17.0498C10.7342 17.5174 10.8754 17.9456 11.0285 18.3283C11.3347 19.0937 11.6492 19.5788 11.8961 19.8399C11.9365 19.8826 11.9711 19.9155 12 19.9407C12.0289 19.9155 12.0635 19.8826 12.1039 19.8399C12.3508 19.5788 12.6653 19.0937 12.9715 18.3283C13.1246 17.9456 13.2658 17.5174 13.3914 17.0499C12.9599 17.0178 12.4964 17 11.9998 17C11.5033 17 11.04 17.0178 10.6086 17.0498ZM13.7889 15.0756C13.2344 15.0268 12.6385 15 11.9998 15C11.3612 15 10.7655 15.0268 10.2111 15.0755C10.1181 14.4235 10.0529 13.7285 10.0214 13H13.9786C13.9471 13.7285 13.8819 14.4236 13.7889 15.0756ZM15.3842 17.3336C15.1734 18.1678 14.9146 18.9187 14.6175 19.562C15.6203 19.2149 16.5326 18.674 17.3096 17.9841C17.1159 17.8875 16.8868 17.7873 16.6184 17.689C16.2677 17.5605 15.8577 17.4384 15.3842 17.3336ZM18.6551 16.441C18.2757 16.2153 17.8246 16.0009 17.3063 15.811C16.8556 15.6459 16.3437 15.4954 15.7672 15.37C15.8749 14.6176 15.9475 13.8235 15.9802 13H19.9381C19.7808 14.2618 19.3295 15.4324 18.6551 16.441ZM8.23282 15.3699C7.65616 15.4953 7.14415 15.6459 6.69335 15.811C6.17514 16.0008 5.72409 16.2152 5.34477 16.4409C4.6704 15.4323 4.21923 14.2618 4.06189 13H8.01975C8.05245 13.8235 8.12511 14.6175 8.23282 15.3699ZM10.0214 11C10.0529 10.2715 10.1181 9.57643 10.2111 8.92442C10.7656 8.97315 11.3615 9.00002 12.0002 9.00002C12.6388 9.00002 13.2345 8.97316 13.7889 8.92446C13.8819 9.57646 13.9471 10.2715 13.9786 11H10.0214ZM8.01975 11C8.05245 10.1765 8.12512 9.38241 8.23283 8.62998C7.65633 8.50463 7.14444 8.3541 6.69374 8.18901C6.17541 7.99914 5.72426 7.7847 5.34488 7.55896C4.67045 8.56761 4.21924 9.73818 4.06189 11H8.01975ZM12.0002 7.00002C11.5036 7.00002 11.0401 6.98222 10.6086 6.95014C10.7342 6.48259 10.8754 6.05442 11.0285 5.67171C11.3347 4.90634 11.6492 4.42118 11.8961 4.16007C11.9365 4.11741 11.9711 4.08451 12 4.05929C12.0289 4.08451 12.0635 4.11741 12.1039 4.16007C12.3508 4.42118 12.6653 4.90634 12.9715 5.67171C13.1246 6.05443 13.2658 6.48261 13.3914 6.95017C12.96 6.98223 12.4967 7.00002 12.0002 7.00002ZM15.9802 11C15.9475 10.1765 15.8749 9.38246 15.7672 8.63006C16.3438 8.5047 16.8558 8.35414 17.3066 8.18901C17.8249 7.99919 18.2759 7.7848 18.6552 7.55912C19.3296 8.56774 19.7808 9.73825 19.9381 11H15.9802ZM16.6187 6.31104C16.8871 6.21275 17.1161 6.11259 17.3097 6.01602C16.5327 5.32603 15.6203 4.78508 14.6175 4.43801C14.9146 5.08132 15.1734 5.83224 15.3842 6.66652C15.8579 6.56169 16.268 6.43951 16.6187 6.31104ZM7.38165 6.31104C7.73229 6.43948 8.1423 6.56163 8.61582 6.66644C8.82663 5.83219 9.08544 5.0813 9.38254 4.43801C8.37973 4.78506 7.46741 5.32596 6.69039 6.0159C6.88411 6.1125 7.1132 6.2127 7.38165 6.31104Z" fill="#0070A6"/>
              </svg>
              <span>Международная перевозка. Проверьте настройки НДС</span>
            </div>
          </template>
          <div class="title mb10">Стоимость услуги</div>
          <div
            v-if="formData.isExistContractTariff && formData.contractUuid"
            class="contract-link"
          >
            <span>Стоимость услуги по договору</span>
            <router-link target="_blank" class="link-style" tag="a" :to="contractLink">{{ formData.contractNumber }}</router-link>
            <span>указана</span>
            <span>{{ formData.vatType === 'NO_VAT' ? 'без НДС' : 'с учетом НДС' }}</span>
          </div>

          <div
            v-if="isNds"
            class="nds-block"
          >
            <div class="title mb10">Налог на добавленную стоимость (НДС)</div>
            <ObRadio
              :model-value="formData.vat"
              label="0%"
              :value-input="0"
              class="mb10"
              data-qa="zeroNds"
              :disabled="!isNew && !isToReExposeFormState"
              :readonly="!isManualInputNds"
              @change="onChangeNds"
            />
            <ObRadio
              :model-value="formData.vat"
              label="20%"
              :value-input="20"
              class="mb10"
              data-qa="twentyNds"
              :disabled="!isNew && !isToReExposeFormState"
              :readonly="!isManualInputNds"
              @change="onChangeNds"
            />
          </div>
          <ObCheckbox
            v-if="isNds && Boolean(formData.vat)"
            v-model="formData.isVatIncluded"
            label="Указана с учетом НДС"
            data-qa="isVatInclude"
            :disabled="!isNew && !isToReExposeFormState"
            @change="onChangeIsVatIncluded"
          />
          <ObCheckbox
            v-model="formData.isIncludedInTariff"
            label="Суммируется в одну строку счета"
            data-qa="isIncludedInTariff"
            :disabled="!isNew || selectedService.isIncludedInTariff"
          />
          <div class="row">
            <div class="col-xs-6">
              <ObInput
                label="Цена за единицу"
                placeholder="Введите цену"
                :value="formData.pricePerService"
                type="money:2"
                sub-title="₽"
                data-qa="pricePerService"
                :min-value="isCorrection ? null : 0"
                :readonly="!isNew && !isToReExposeFormState || formData.isExistContractTariff"
                property="pricePerService"
                @input="onInputTariff"
              />
            </div>
            <div class="col-xs-6">
              <ObInput
                v-if="isNds && Boolean(formData.vat)"
                label="НДС"
                :readonly="true"
                :value="vatValue"
                sub-title="₽"
                type="money:2"
                data-qa="vatValue"
              />
            </div>
          </div>
          <div class="row">
            <div class="col-xs-6">
              <ob-stepper
                label="Количество"
                v-model="formData.count"
                :readonly="!isNew"
                :min-value="isCorrection ? -999999999 : 1"
                property="count"
              />
            </div>
          </div>
        </div>
      </transition>
      <ObTextarea
        v-model="formData.comments"
        label="Комментарий"
        placeholder="Введите комментарий"
        class="mb30 mt30"
        :readonly="!isNew && !isToReExposeFormState"
      />
      <template v-if="formData.fileUuids && formData.fileUuids.length || isNew">
        <div class="title">Прикрепленные файлы</div>
        <ObUploader
          ref="uploader"
          multiple
          :value="currentFiles"
          data-qa="uploader"
          :is-read-only="!isNew"
          :upload-method="uploadMethod"
          @process-start="startUploadFiles"
          @change="onUploadHandler"
        />
      </template>
      <ObModal
        ref="confirmModal"
        :title="`Подтверждение ${isCorrection ? 'корректировки' : 'услуги'} за Заказчика`"
        :is-nested="true"
        :is-show-controls="true"
        size="md"
        ok-text="Да, подтвердить"
        cancel-text="Отмена"
        @submit="onConfirmService"
      >
        <div class="confirm-modal__info">
          <p>Вы уверены, что хотите подтвердить эту {{ isCorrection ? 'корректировку' : 'услугу' }} за заказчика?</p>
          <div class="info-row">
            <div class="title">
              Наименование:
            </div>
            <div class="description">
              {{ dataSource.title }}
            </div>
          </div>
          <div class="info-row">
            <div class="title">
              Заказчик:
            </div>
            <div class="description">
              {{ servicesInfo.clientTitle }}
            </div>
          </div>
          <div class="info-row">
            <div class="title">
              Сумма:
            </div>
            <div class="description">
              {{ dataSource.totalPrice / 100 | currency }} ₽
            </div>
          </div>
        </div>
      </ObModal>
    </ob-form>
  </ObModal>
</template>

<script>
  import { mapGetters } from 'vuex'
  import api from '@/api'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import cloneDeep from 'clone-deep'
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObModal from 'common-components/src/obComponents/obModal'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObRadio from 'common-components/src/obComponents/obRadio'
  import ObSelect from 'common-components/src/obComponents/obSelect'
  import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
  import ObStepper from 'common-components/src/obComponents/obStepper'
  import ObUploader from 'common-components/src/obComponents/obUploader'
  import ObTextarea from 'common-components/src/obComponents/obTextarea'
  import StatusBlock from './slots/status'
  import { required, requiredIf } from 'vuelidate/lib/validators'
  import debounce from "debounce"

  export default {
    name: 'OrderAdditionalServiceForm',
    components: {
      ObSelect,
      ObInput,
      ObForm,
      ObCheckbox,
      ObStepper,
			ObModal,
      ObUploader,
      StatusBlock,
      ObTextarea,
      ObRadio
    },
    props: {
      order: {
        type: Object,
        default: () => {}
      },
    },
    mixins: [
      FormValidationMixin
    ],
    data () {
      return {
        api,
        servicesInfo: {},
        participantInfo: null,
        reExposeParticipantInfo: null,
        reExposeServicesInfo: null,
        isLoading: false,
        selectedService: {},
        location: {},
        locationFrom: {},
        locationTo: {},
        isManualInputNds: false
      }
    },
    watch: {
      'order.uuid': {
        immediate: true,
        handler () {
          this.getServicesInfo()
        }
      },
      'formData.fileUuids': {
        handler (value) {
          if (!value) {
            this.$refs.uploader && this.$refs.uploader.clearFiles()
          }
        },
        deep: true
      }
    },
    computed: {
      ...mapGetters({
        participantUuid: 'user/participantUuid',
        isClicar: 'user/isClicar',
        firstOrder: 'order/order'
      }),
      serviceFormTitle () {
        if (this.isToReExposeFormState) {
          return 'Перевыставление дополнительной услуги'
        }
        if (this.isCorrection) {
          return this.dataSource?.uuid ? 'Корректировка' : 'Добавление корректировки'
        } else {
          return this.dataSource?.uuid ? 'Дополнительная услуга' : 'Добавление дополнительной услуги'
        }
      },
      firstOrderUuid () {
        return this.firstOrder && !this.firstOrder.isSuborder ? this.firstOrder.uuid : null
      },
      isNew () {
        return !this.dataSource.uuid
      },
      isNds () {
        const isNds = this.isNew ? this.selectedService?.isVatCharged : this.dataSource?.isVatCharged
        return Boolean(this.isVatPayer && isNds)
      },
      isCorrection () {
        return this.dataSource.serviceKind === 'CORRECTION'
      },
      isAdditionalService () {
        return this.dataSource.serviceKind === 'ADDITIONAL_SERVICE'
      },
      isInternational () {
        return ['FOREIGN', 'CROSSBOARDING'].includes(this.transboundary)
      },
      isVatPayer () {
        return Boolean(this.isToReExposeFormState ? this.reExposeParticipantInfo?.isVatPayer : this.participantInfo?.isVatPayer)
      },
      transboundary () {
        return this.isToReExposeFormState ? this.reExposeServicesInfo?.transboundary : this.servicesInfo?.transboundary
      },
      routeCategory () {
        return this.isToReExposeFormState ? this.reExposeServicesInfo?.routeCategory : this.servicesInfo?.routeCategory
      },
      formModel () {
        const _self = this

        return {
          orderUuid: {
            value: () => _self.order.uuid
          },
          orderKind: {
            value: () => _self.order.isSuborder ? 'SUBORDER' : 'ORDER'
          },
          serviceUuid: {
            value: '',
            validator: {
              required
            }
          },
          title: {
            value: '',
            validator: {
              required
            }
          },
          geography: {
            value: '',
            validator: {
              required
            }
          },
          serviceUnitUuid: {
            value: '',
            validator: {
              required
            }
          },
          serviceUnitTitle: {
            value: '',
            validator: {
              required
            }
          },
          serviceKind: {
            value: () => _self.dataSource.serviceKind
          },
          count: {
            value: 1,
            validator: {
              notNull: {
                method: (value, vm) => {
                  if (_self.isAdditionalService) {
                    return value > 0
                  } else if (_self.isCorrection && vm && +vm.pricePerService === 0) {
                    return +value !== 0
                  } else {
                    return true
                  }
                },
                error: `${_self.isAdditionalService ? 'Должно быть не менее 1' : 'Не может быть 0'}`
              }
            }
          },
          pricePerService: {
            value: '',
            validator: {
              required,
              notNull: {
                method: (value, vm) => {
                  if (_self.isAdditionalService) {
                    return +value > 0
                  } else if (_self.isCorrection && vm && +vm.count === 0) {
                    return +value !== 0
                  } else {
                    return true
                  }
                },
                error: 'Не может быть 0'
              }
            }
          },
          vat: {
            value: () => _self.dataSource?.addServiceTotalAmount?.vatRate || _self.servicesInfo.vat || 0
          },
          vatType: {
            value: () => _self.dataSource?.addServiceTotalAmount?.vatType
          },
          isVatIncluded: {
            type: 'boolean',
            value: () => Boolean(_self.isVatPayer &&_self.servicesInfo.vat),
            validator: {
              required
            }
          },
          isIncludedInTariff: {
            type: 'boolean',
            value: false
          },
          locationFromUuid: {
            value: '',
            validator: {
              required: requiredIf(function () {
                return _self.formData.geography === 'FROM_TO'
              })
            }
          },
          locationToUuid: {
            value: '',
            validator: {
              required: requiredIf(function () {
                return _self.formData.geography === 'FROM_TO'
              })
            }
          },
          locationUuid: {
            value: '',
            validator: {
              required: requiredIf(function () {
                return _self.formData.geography === 'WHERE'
              })
            }
          },
          assignedTariff: {
            nested_fields: {
              priceWithVat: {
                value: () => _self.dataSource?.addServiceTotalAmount?.priceWithVat
              },
              priceWithoutVat: {
                value: () => _self.dataSource?.addServiceTotalAmount?.priceWithoutVat
              },
              vatPrice: {
                value: () => _self.dataSource?.addServiceTotalAmount?.vatPrice
              }
            }
          },
          visitPointAddressTitle: {
            value: ''
          },
          visitPointUuid: {
            value: ''
          },
          comments: {
            value: ''
          },
					fileUuids: {
						value: null
					},
          isToReExpose: {
            value: false
          }
        }
      },
      dropdownMenu () {
        return [
          {
						title: 'Подтвердить за Заказчика',
						method: this.openConfirmModal,
            isHidden: this.dataSource.status !== 'NEW' || !this.isClicar || !this.isCreator || this.order.isSuborder || !this.order.isEditable
          },
					{
						title: this.isCreator ? 'Отменить' : 'Отклонить',
						method: this.cancelService,
						isHidden: this.dataSource.status !== 'NEW' || !this.order.isEditable,
						className: 'color-error'
					}
        ]
      },
      vatValue () {
        const vatPrice = Math.abs(this.formData.assignedTariff?.vatPrice)
        return this.isNew || this.isToReExposeFormState ? vatPrice : vatPrice / this.formData.count
      },
      isReadonlyForm () {
        return !this.isNew && !this.isToApprove && !this.isToReExposeFormState
      },
      okTextForm () {
        if (this.isToReExposeFormState) {
          return 'Перевыставить'
        }
        if (this.isToApprove) {
          return 'Подтвердить'
        }

        return 'Добавить'
      },
      isCreator () {
        return this.dataSource.creatorUuid === this.participantUuid
      },
      isToApprove () {
        return this.dataSource.status === 'NEW' && !this.isCreator && this.order.isEditable
      },
      isToReExpose () {
        return !this.isCorrection && this.order.isSuborder && ['TO_CROSS_CHARGE', 'DECLINED'].includes(this.dataSource.crossCharged) && this.isClicar
      },
      isToReExposeFormState () {
        return this.formData.isToReExpose
      },
      isSubmitDisabled () {
        if (this.isToApprove) {
          return false
        }

        return undefined
      },
      btnModal () {
        const isSuborder = this.order.isSuborder
        const isBlockReExpose = isSuborder ? !this.order.isEditable || !this.firstOrder?.isEditable : true

        if (!isBlockReExpose && this.isToReExpose && !this.isToReExposeFormState) {
          return 'Перевыставить'
        }

        return null
      },
      contractLink () {
        return { name: 'contracts__detail', params: { id: this.formData.contractUuid } }
      },
			uploadMethod () {
				return api.files.postFile
			},
			currentFiles () {
				return this.dataSource.filesData
			}
    },
    methods: {
      open () {
        this.$refs.modal.open()
        this.$nextTick(async () => {
          if (!this.participantInfo) {
            this.participantInfo = await api.orderProcess.getPaticipantInfo({ uuid: this.order?.contractorUuid })
          }
          // if (this.isToReExpose) {
          //   let { tariff } = await this.getServiceTariff({ service: this.dataSource })
          //   this.formData.isExistContractTariff = Boolean(tariff)
          //   tariff && await this.calcTariff(tariff)
          // }
        })
      },
      close () {
        this.$refs.modal.close()
      },
      setVatParams () {
        if (!this.isNds) {
          this.formData.vatType = 'NO_VAT'
          this.formData.vat = 0
        } else {
          if (['URBAN', 'INTERURBAN'].includes(this.routeCategory)) {
            this.isManualInputNds = false
            this.formData.vatType = 'TWENTY'
            this.formData.vat = 20
          } else if (['INTERNATIONAL'].includes(this.routeCategory)) {
            this.isManualInputNds = true
            this.formData.vatType = 'TWENTY'
            this.formData.vat = 20
          } else {
            this.isManualInputNds = false
            this.formData.vatType = 'NO_VAT'
            this.formData.vat = 0
          }
        }
      },
      async onSubmitHandler () {
        if (this.isNew) {
          await this.addService()
        } else if (this.isToReExposeFormState) {
          await this.reExposeService()
        } else if (this.isToApprove) {
          await this.approveService()
        }
      },
			startUploadFiles () {
				this.formData.fileUuids = 'loading'
			},
			async onUploadHandler (data) {
				data = data.map(file => file.uuid)

				this.formData.fileUuids = data
			},
      async onSelectService (data) {
        let { geography, isVatIncluded, pricePerService, serviceUnitTitle, serviceUnitUuid, title, serviceUuid, isIncludedInTariff } = data

        let tariffData = ['WHERE', 'FROM_TO'].includes(data.geography) || this.isCorrection ? {} : await this.getServiceTariff({ service: data })
        const { tariff, contractNumber, contractUuid } = tariffData

        this.selectedService = data
        this.location = {}
        this.locationFrom = {}
        this.locationTo = {}

        this.formData = {
          ...this.formData,
          serviceUuid,
          geography,
          isVatIncluded: Boolean(isVatIncluded),
          pricePerService: tariff || pricePerService,
          serviceUnitTitle,
          serviceUnitUuid,
          title,
          vat: this.servicesInfo.vat || 0,
          isExistContractTariff: Boolean(tariff),
          locationUuid: '',
          locationFromUuid: '',
          locationToUuid: '',
          isIncludedInTariff,
          contractNumber,
          contractUuid
        }

        this.$nextTick(() => {
          this.setVatParams()
        })
      },
      onSelectLocation (data, type) {
        if (type === 'WHERE') {
          this.location = data
        }
        if (type === 'FROM') {
          this.locationFrom = data
        }
        if (type === 'TO') {
          this.locationTo = data
        }

        this.$nextTick(async () => {
          if (this.selectedService.geography === 'FROM_TO' && (!this.formData.locationFromUuid || !this.formData.locationToUuid)) {
            return false
          }

          let tariffData = this.isCorrection ? {} : await this.getServiceTariff({ service: this.formData })
          const { tariff, contractNumber, contractUuid } = tariffData

          this.formData.pricePerService = tariff
          this.formData.isExistContractTariff = Boolean(tariff)
          this.formData.contractNumber = contractNumber
          this.formData.contractUuid = contractUuid

          tariff && await this.calcTariff(tariff)
        })
      },
      async getServiceTariff ({ service }) {
        let { geography, serviceUuid, locationFromUuid, locationToUuid, locationUuid } = service
        try {
          return await api.orderProcess.getAdditionalServiceTariff({
            clientUuid: this.order.clientUuid,
            contractorUuid: this.order.contractorUuid,
            pvpDate: this.order.pvpDt,
            serviceUuid,
            geography,
            locationFromUuid,
            locationToUuid,
            locationUuid,
            visitPointUuid: locationUuid
          })
        } catch (e) {
          return {}
        }
      },
      async getServicesInfo () {
        this.servicesInfo = await api.orderProcess.getAdditionalServicesInfo({ uuid: this.order.uuid, isSuborder: this.order.isSuborder })
      },
      onInputTariff: debounce(async function(value) {
        this.formData.pricePerService = value
        await this.calcTariff(value)
      }, 500),
      async calcTariff (value) {
        if (this.formData.vat) {
          const postData = {
            vatRate: this.formData.vat,
            quantity: 1
          }

          if (this.formData.vat && this.formData.isVatIncluded) {
            postData.priceWithVat = value
          } else {
            postData.priceWithoutVat = value
          }
          let { totalWithoutVat, totalWithVat, totalVat } = await api.orderProcess.vatCalculation({ list: [postData] })

          if (!this.formData.assignedTariff) {
            this.formData.assignedTariff = {}
          }

          this.formData.assignedTariff.priceWithoutVat = totalWithoutVat
          this.formData.assignedTariff.priceWithVat = totalWithVat
          this.formData.assignedTariff.vatPrice = totalVat
        } else {
          if (!this.formData.assignedTariff) {
            this.formData.assignedTariff = {}
          }
          this.formData.assignedTariff.priceWithoutVat = value
          this.formData.assignedTariff.priceWithVat = value
          this.formData.assignedTariff.vatPrice = 0
        }
      },
      async onChangeNds (value) {
        if (value) {
          this.formData.vat = 20
          this.formData.vatType = 'TWENTY'
          this.formData.isVatIncluded = true
        } else {
          this.formData.vat = 0
          this.formData.vatType = 'ZERO'
          this.formData.isVatIncluded = false
        }

        await this.calcTariff(this.formData.pricePerService)
      },
      onChangeIsVatIncluded () {
        this.$nextTick(() => {
          this.calcTariff(this.formData.pricePerService)
        })
      },
      async addService () {
        let data = cloneDeep(this.formData)
        data.visitPointUuid = this.location.visitPointUuid || null
        data.visitPointAddressTitle = this.location.addressTitle || null
        data.locationFromTitle = this.locationFrom.title || null
        data.locationToTitle = this.locationTo.title || null

        data.pricePerService = data.assignedTariff?.priceWithoutVat || data.pricePerService

        try {
          this.isLoading = true
          await api.orderProcess.addAdditionalService({ data })
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: e?.error
          })
        } finally {
          this.isLoading = false
        }

        this.$emit('submit')
      },
      async cancelService () {
        const { uuid } = this.dataSource
        try {
          this.isLoading = true
          await api.orderProcess.cancelAdditionalService({ uuid, status: 'DECLINED' })
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: e?.error
          })
        } finally {
          this.isLoading = false
        }

        this.$emit('cancel')
      },
      async approveService () {
        const { uuid } = this.dataSource
        try {
          this.isLoading = true
          await api.orderProcess.cancelAdditionalService({ uuid, status: 'APPROVED' })
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: e?.error
          })
        } finally {
          this.isLoading = false
        }

        this.$emit('approved')
      },
      async toReExposeService () {
        this.isLoading = true

        this.reExposeServicesInfo = await api.orderProcess.getAdditionalServicesInfo({ uuid: this.firstOrderUuid, isSuborder: false })
        this.reExposeParticipantInfo = await api.orderProcess.getPaticipantInfo({ uuid: this.firstOrder.contractorUuid })
        this.formData.isToReExpose = true

        this.$nextTick(async () => {
          this.setVatParams()
          await this.calcTariff(this.formData.pricePerService)
        })

        this.isLoading = false
      },
      async reExposeService () {
        try {
          this.isLoading = true
          await api.orderProcess.reExposeAdditionalService({
            orderUuid: this.firstOrderUuid,
            pricePerService: this.formData.assignedTariff?.priceWithoutVat || this.formData.pricePerService,
            parentServiceUuid: this.dataSource.uuid,
            isVatIncluded: Boolean(this.formData.isVatIncluded),
            vat: this.formData.vat || 0,
            vatType: this.formData.vatType
          })
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: e?.error
          })
        } finally {
          this.isLoading = false
        }

        this.$emit('re-expose', {
          firstOrderUuid: this.firstOrderUuid
        })
      },
      locationsList (type) {
        let excludeUuid
        let list = this.servicesInfo.locations || []

        if (!type) {
          list = this.servicesInfo.points
        }

        if (type === 'FROM') {
          excludeUuid = this.formData.locationToUuid
        }
        if (type === 'TO') {
          excludeUuid = this.formData.locationFromUuid
        }

        return list.filter((location) => {
          return !type || location.uuid !== excludeUuid
        })
      },
			openConfirmModal () {
				this.$refs.confirmModal.open()
			},
      async onConfirmService () {
        this.$refs.confirmModal.close()
        await this.approveService()
      }
    }
  }
</script>

<style lang='scss' scoped>
  @import '../../../../../../node_modules/common-components/src/static/css/mixins';

  .contract-link {
    margin-top: 15px;
    margin-bottom: 20px;
    a, span:not(:first-child) {
      margin-left: 5px;
    }
  }

  .contract-service-form {
    .main-title {
      @include font-mixin(20px, 28px, 600, $color-text-base, 0.4px);
    }

    .sub-title {
      margin-bottom: 10px;
      @include font-mixin(16px, 24px, 600, $color-text-base, 0.4px);
      .icon {
        margin-left: 3px;
        font-size: 14px;
        font-weight: bold;
        color: $color-grey-span;
      }
    }

    .tariff-input {
      width: 193px;
    }
  }

	.confirm-modal__info {
		p {
			margin-bottom: 25px;
			font-size: 16px!important;
		}
		.info-row {
			display: flex;
			margin-bottom: 2px;
			@include font-mixin(16px, 20px, 400, $color-text-base, 0.2px);
			.title {
				width: 140px;
				color: $color-grey-label;
			}
			.description {

			}
		}
	}
</style>

<style lang="scss" scoped>
  @import '../../../../../../node_modules/common-components/src/static/css/mixins';
  .order-additional-service-form {
    .mt20 {
      margin-top: 20px!important;
    }

    .mb10 {
      margin-bottom: 10px;
    }

    .mb15 {
      margin-bottom: 15px!important;
    }

    .mb30 {
      margin-bottom: 30px!important;
    }

    .mt30 {
      margin-top: 30px!important;
    }

    .mb40 {
      margin-bottom: 30px!important;
    }

    .mt40 {
      margin-top: 40px !important;
    }

    .ml25 {
      margin-left: 25px;
    }

    &::v-deep {
      .ob-checkbox-container {
        margin-bottom: 8px;
      }
      .service-title__status {
        color: $color-text-base!important;
      }
      .service-status__row {
        margin-bottom: 10px;
      }
    }

    .title {
      margin-top: 30px;
      margin-bottom: 5px;
      @include font-mixin(16px, 24px, 600, $color-text-base , 0.4px);
    }

    .checkbox-input {
      display: flex;
      justify-content: flex-start;
      align-items: center;

      .ob-checkbox-container {
        flex-shrink: 0;
        margin-left: 20px;
      }
    }

    .input-nds {
      width: 145px;
    }

    .nds-block {
      margin-left: 20px;
      .title {
        margin-top: 0!important;
      }
    }

    .international-block {
      height: 64px;
      margin-top: 30px;
      margin-bottom: 30px;
      display: flex;
      align-items: center;
      padding: 0 20px;
      border-left: 6px solid $diamond-orange-yellow;
      box-shadow: 0px 4px 20px rgba(25, 30, 50, 0.2);
      svg {
        margin-right: 20px;
      }
      span {
        @include font-mixin(14px, 18px, 400);
      }
    }

    .color-error {
      button {
        color: $color-error;
      }
    }

    .fadeIn-enter,
    .fadeIn-leave-to {
      opacity: 0;
    }

    .fadeIn-enter-active,
    .fadeIn-leave-active {
      transition: opacity .3s ease-in-out;
    }
  }
</style>
